diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
index 074da2f85..eb60a4427 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
@@ -5,6 +5,8 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockModelCandle<T extends BlockLogic> extends BlockModelStandard<T> {
     public BlockModelCandle(Block<T> block) {
@@ -12,9 +14,9 @@ public class BlockModelCandle<T extends BlockLogic> extends BlockModelStandard<T
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        boolean isLit = (renderBlocks.blockAccess.getBlockMetadata(x, y, z) & 0b00000001) == 0;
-        float brightness = isLit ? 1.0f : getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        boolean isLit = (worldSource.getBlockMetadata(x, y, z) & 0b00000001) == 0;
+        float brightness = isLit ? 1.0f : renderBlocks.getBlockBrightness(worldSource, x, y, z);
 
         float minX = x + 0.5f - (1.5f / 16f);
         float minY = y + 0f;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChest.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChest.java
index ab6f709d6..b753a6136 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChest.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChest.java
@@ -8,8 +8,15 @@ import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.DisplayPos;
 
 public class BlockModelChest<T extends BlockLogic> extends BlockModelStandard<T> {
+    protected static final DisplayPos CHEST_GUI = new DisplayPos(0, 0, 0, 30, 45, 0, 0.625f, 0.625f, 0.625f);
+    protected static final DisplayPos CHEST_HEAD = new DisplayPos(0, 0, 0, 0, -180, 0, 1f, 1f, 1f);
+    protected static final DisplayPos CHEST_FIRST_PERSON_RIGHT_HAND = new DisplayPos(0, 0, 0, 0, -45, 0, 0.4f, 0.4f, 0.4f);
+
     protected IconCoordinate chestFrontSingle;
     protected IconCoordinate chestFrontLeft;
     protected IconCoordinate chestFrontRight;
@@ -30,17 +37,20 @@ public class BlockModelChest<T extends BlockLogic> extends BlockModelStandard<T>
         chestBackRight = TextureRegistry.getTexture(rootKey + "right_back");
         chestSide = TextureRegistry.getTexture(rootKey + "side");
         chestTop = TextureRegistry.getTexture(rootKey + "top");
+
+        setDisplayPos(DisplayPos.GUI, CHEST_GUI);
+        setDisplayPos(DisplayPos.HEAD, CHEST_HEAD);
+        setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, CHEST_FIRST_PERSON_RIGHT_HAND);
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        int meta = worldSource.getBlockMetadata(x, y, z);
         final Direction dir = BlockLogicChest.getDirectionFromMeta(meta);
         switch (dir) {
             case NORTH:
                 renderBlocks.uvRotateTop = 3;
                 break;
-
             case EAST:
                 renderBlocks.uvRotateTop = 2;
                 break;
@@ -50,13 +60,13 @@ public class BlockModelChest<T extends BlockLogic> extends BlockModelStandard<T>
                 break;
         }
 
-        renderStandardBlock(tessellator, block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z), x, y, z);
-        resetRenderBlocks();
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, block.getBlockBoundsFromState(worldSource, x, y, z), x, y, z);
+        renderBlocks.resetRenderBlocks();
         return true;
     }
 
     @Override
-    public IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side) {
+    public @Nullable IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side) {
         int meta = blockAccess.getBlockMetadata(x, y, z);
 
         Side facing = BlockLogicChest.getDirectionFromMeta(meta).getSide();
@@ -107,7 +117,7 @@ public class BlockModelChest<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
         if (side == Side.SOUTH) return chestFrontSingle;
         if (side.isHorizontal()) return chestSide;
         return chestTop;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChestPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChestPainted.java
index 785cc6e31..f2b7c1592 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChestPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChestPainted.java
@@ -9,6 +9,7 @@ import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelChestPainted<T extends BlockLogic> extends BlockModelChest<T> {
     public static final IconCoordinate[][] texCoords = new IconCoordinate[DyeColor.COLOR_AMOUNT][];
@@ -42,7 +43,7 @@ public class BlockModelChestPainted<T extends BlockLogic> extends BlockModelChes
     }
 
     @Override
-    public IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side) {
+    public @Nullable IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side) {
         int meta = blockAccess.getBlockMetadata(x, y, z);
         int color = meta >> 4;
 
@@ -90,7 +91,7 @@ public class BlockModelChestPainted<T extends BlockLogic> extends BlockModelChes
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
         int color = data >> 4;
         if (side == Side.SOUTH) return texCoords[color][TEX_SINGLE_FRONT];
         if (side.isHorizontal()) return texCoords[color][TEX_SIDE];
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
index 3a332973e..af2bcd3d6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
@@ -7,6 +7,9 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelCropsPumpkin<T extends BlockLogic> extends BlockModelStandard<T> {
     public static final IconCoordinate[] GROWTH_STAGE_TEXTURES_TOP = {
@@ -29,16 +32,16 @@ public class BlockModelCropsPumpkin<T extends BlockLogic> extends BlockModelStan
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
-        	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+        	tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
         }else {
-        	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        	brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
         }
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
 
-        final int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+        final int meta = worldSource.getBlockMetadata(x, y, z);
         IconCoordinate leafTexture = LEAF_TEXTURE;
         if(renderBlocks.overrideBlockTexture != null)
         {
@@ -75,7 +78,7 @@ public class BlockModelCropsPumpkin<T extends BlockLogic> extends BlockModelStan
         tessellator.addVertexWithUV(xMin, yMin, zMax, uMin, vMax);
         tessellator.addVertexWithUV(xMin, yMin, zMin, uMax, vMax);
         tessellator.addVertexWithUV(xMax + extra, yMax, zMin, uMax, vMin);
-        if (meta >= 1) renderStandardBlock(tessellator, block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z), x, y, z);
+        if (meta >= 1) renderBlocks.renderStandardBlock(tessellator, worldSource, this, block.getBlockBoundsFromState(worldSource, x, y, z), x, y, z);
         return true;
     }
     @Override
@@ -84,7 +87,7 @@ public class BlockModelCropsPumpkin<T extends BlockLogic> extends BlockModelStan
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
         if (data < 1 || data > 4) {
             data = 1;
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
index 0b50edcf6..0f6b485c7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
@@ -9,6 +9,9 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicCropsWheat;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelCropsWheat<T extends BlockLogic> extends BlockModelStandard<T> {
     public final IconCoordinate[] growthStageTextures = {
@@ -28,16 +31,16 @@ public class BlockModelCropsWheat<T extends BlockLogic> extends BlockModelStanda
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
-        	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+        	tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
         }else {
-        	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        	brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
         }
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
 
-        IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.BOTTOM, renderBlocks.blockAccess.getBlockMetadata(x, y, z));
+        IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.BOTTOM, worldSource.getBlockMetadata(x, y, z));
         if(renderBlocks.overrideBlockTexture != null)
         {
             texture = renderBlocks.overrideBlockTexture;
@@ -97,7 +100,7 @@ public class BlockModelCropsWheat<T extends BlockLogic> extends BlockModelStanda
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         return growthStageTextures[MathHelper.clamp(data, 0, BlockLogicCropsWheat.MAX_GROWTH_STATE)];
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
index fbabfa513..c0a0ff117 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
@@ -8,15 +8,18 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
+import org.useless.dragonfly.DisplayPos;
 
 public class BlockModelCrossedSquares<T extends BlockLogic> extends BlockModelStandard<T> {
     public BlockModelCrossedSquares(Block<T> block) {
         super(block);
     }
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         if (LightmapHelper.isLightmapEnabled()){
             brightness = 1f;
         }
@@ -27,10 +30,10 @@ public class BlockModelCrossedSquares<T extends BlockLogic> extends BlockModelSt
         GL11.glColor4f(1f, 1f, 1f,1f);
         if(renderBlocks.useInventoryTint)
         {
-            int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
-             r = (float)(color >> 16 & 0xff) / 255F;
-             g = (float)(color >> 8 & 0xff) / 255F;
-             b = (float)(color & 0xff) / 255F;
+            int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata, 0);
+            r = (float)(color >> 16 & 0xff) / 255F;
+            g = (float)(color >> 8 & 0xff) / 255F;
+            b = (float)(color & 0xff) / 255F;
         }
         final float yOffset = 0.0F;
 
@@ -48,9 +51,6 @@ public class BlockModelCrossedSquares<T extends BlockLogic> extends BlockModelSt
 
         tessellator.startDrawingQuads();
         tessellator.setColorRGBA_F(r * brightness, g * brightness, b * brightness, alpha);
-        if (!LightmapHelper.isLightmapEnabled()) { // TODO figure out what the hell is wrong with normals when lightmap is enabled
-            tessellator.setNormal(0.0F, 1.0F, 0.0F);
-        }
         if (LightmapHelper.isLightmapEnabled() && lightmapCoordinate != null){
             tessellator.setLightmapCoord(lightmapCoordinate);
         }
@@ -87,15 +87,15 @@ public class BlockModelCrossedSquares<T extends BlockLogic> extends BlockModelSt
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
         float brightness = 1.0f;
         if(!LightmapHelper.isLightmapEnabled()) {
-        	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        	brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
         }else {
-        	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+        	tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
         }
         
-        int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(renderBlocks.blockAccess, x, y, z);
+        int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(worldSource, x, y, z, 0);
         float r = (float)(color >> 16 & 0xff) / 255F;
         float g = (float)(color >> 8 & 0xff) / 255F;
         float b = (float)(color & 0xff) / 255F;
@@ -115,7 +115,7 @@ public class BlockModelCrossedSquares<T extends BlockLogic> extends BlockModelSt
             zd += ((double)((float)(dRandom >> 24 & 15L) / 15F) - 0.5D) * 0.5D;
         }
 
-        int metadata = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+        int metadata = worldSource.getBlockMetadata(x, y, z);
         IconCoordinate texIndex = getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata);
         if(renderBlocks.overrideBlockTexture != null)
         {
@@ -156,8 +156,4 @@ public class BlockModelCrossedSquares<T extends BlockLogic> extends BlockModelSt
     public boolean shouldItemRender3d() {
         return false;
     }
-    @Override
-    public float getItemRenderScale() {
-        return 0.5f;
-    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrystallineNetherrack.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrystallineNetherrack.java
index ef7308b5d..866218565 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrystallineNetherrack.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrystallineNetherrack.java
@@ -1,15 +1,14 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
-import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
@@ -21,22 +20,22 @@ public class BlockModelCrystallineNetherrack<T extends BlockLogic> extends Block
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        AABB bounds = block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z);
-        renderStandardBlock(tessellator, bounds, x, y, z, 1.0f, 1.0f, 1.0f);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        AABB bounds = block.getBlockBoundsFromState(worldSource, x, y, z);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z, 1.0f, 1.0f, 1.0f);
         renderBlocks.overrideBlockTexture = overlay;
-        renderStandardBlock(tessellator, bounds, x, y, z);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         renderBlocks.overrideBlockTexture = null;
         return true;
     }
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         renderBlocks.useInventoryTint = false;
-        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
+        super.renderStandalone(tessellator, metadata, brightness, alpha, lightmapCoordinate);
         renderBlocks.useInventoryTint = true;
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
-        int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
+        int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata, 0);
         float r = (float)(color >> 16 & 0xff) / 255F;
         float g = (float)(color >> 8 & 0xff) / 255F;
         float b = (float)(color & 0xff) / 255F;
@@ -47,27 +46,27 @@ public class BlockModelCrystallineNetherrack<T extends BlockLogic> extends Block
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
-        renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
+        renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
         tessellator.draw();
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
-        renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
+        renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
         tessellator.draw();
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
-        renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
+        renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
         tessellator.draw();
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
-        renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
+        renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
         tessellator.draw();
         tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
-        renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
+        renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
         tessellator.draw();
         tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
-        renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
+        renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
         tessellator.draw();
         GL11.glTranslatef(0.5F, 0.5F, 0.5F);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 6159348c8..40e937881 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -1,10 +1,15 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.util.dispatch.Dispatcher;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.data.block.mojang.BlockModelMojangData;
+
+import java.util.Objects;
 
 import static net.minecraft.client.render.block.model.BlockModelStandard.BLOCK_TEXTURES;
 import static net.minecraft.client.render.block.model.BlockModelStandard.OVERBRIGHT_TEXTURES;
@@ -39,9 +44,20 @@ public class BlockModelDispatcher
     {
         return modelEmpty;
     }
-    private BlockModelDispatcher()
-    {
+
+    private @NotNull BlockModelMojangData loadDataModel(@NotNull String id) {
+        Minecraft mc = Minecraft.getMinecraft();
+        return Objects.requireNonNull(BlockModelMojangData.Cache.loadModelData(mc.texturePackList, id), "Cannot find model for id '" + id + "'!");
+    }
+
+    private BlockModelDispatcher() {
         instance = this;
+        reload();
+    }
+
+    public void reload() {
+        BlockModelMojangData.Cache.resetCache();
+        dispatches.clear();
         addDispatch(new BlockModelStandard<>(Blocks.STONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/stone"));
         addDispatch(new BlockModelStandard<>(Blocks.BASALT).setAllTextures(BLOCK_TEXTURES, "minecraft:block/basalt"));
         addDispatch(new BlockModelStandard<>(Blocks.LIMESTONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/limestone"));
@@ -621,13 +637,15 @@ public class BlockModelDispatcher
             .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/bottom", Side.BOTTOM)
             .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/idle_front", Side.NORTH)
             .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/idle_back", Side.SOUTH)
-            .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/side", Side.WEST, Side.EAST));
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/side", Side.WEST)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/side_slot", Side.EAST));
         addDispatch(new BlockModelHorizontalRotation<>(Blocks.TROMMEL_ACTIVE)
             .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/top", Side.TOP)
             .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/bottom", Side.BOTTOM)
             .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/active_front", Side.NORTH)
             .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/active_back", Side.SOUTH)
-            .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/side", Side.WEST, Side.EAST, Side.SOUTH));
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/side", Side.WEST)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/side_slot", Side.EAST));
 
         addDispatch(new BlockModelStandard<>(Blocks.CHEST_LEGACY).setAllTextures(BLOCK_TEXTURES, "minecraft:block/chest/planks/top"));
         addDispatch(new BlockModelStandard<>(Blocks.CHEST_LEGACY_PAINTED).setAllTextures(BLOCK_TEXTURES, "minecraft:block/chest/planks/top"));
@@ -650,7 +668,7 @@ public class BlockModelDispatcher
             .setTex(BLOCK_TEXTURES, "minecraft:block/slate_side", S_SIDES));
         addDispatch(new BlockModelLayer<>(Blocks.LAYER_ASH).setAllTextures(BLOCK_TEXTURES, "minecraft:block/block_ash"));
 
-        addDispatch(new BlockModelIce<>(Blocks.ICE).onRenderLayer(1).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ice"));
+        addDispatch(new BlockModelTransparent<>(Blocks.ICE, false).onRenderLayer(1).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ice"));
         addDispatch(new BlockModelStandard<>(Blocks.PERMAICE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/permaice"));
 
         addDispatch(new BlockModelStandard<>(Blocks.BLOCK_SNOW).setAllTextures(BLOCK_TEXTURES, "minecraft:block/block_snow"));
@@ -762,6 +780,17 @@ public class BlockModelDispatcher
 
         addDispatch(new BlockModelEmpty<>(Blocks.STATUE_STONE_LOWER).setAllTextures(BLOCK_TEXTURES, "minecraft:block/stone"));
         addDispatch(new BlockModelEmpty<>(Blocks.STATUE_STONE_UPPER).setAllTextures(BLOCK_TEXTURES, "minecraft:block/stone"));
+        addDispatch(new BlockModelEmpty<>(Blocks.STATUE_BASALT_LOWER).setAllTextures(BLOCK_TEXTURES, "minecraft:block/basalt"));
+        addDispatch(new BlockModelEmpty<>(Blocks.STATUE_BASALT_UPPER).setAllTextures(BLOCK_TEXTURES, "minecraft:block/basalt"));
+        addDispatch(new BlockModelEmpty<>(Blocks.STATUE_LIMESTONE_LOWER).setAllTextures(BLOCK_TEXTURES, "minecraft:block/limestone"));
+        addDispatch(new BlockModelEmpty<>(Blocks.STATUE_LIMESTONE_UPPER).setAllTextures(BLOCK_TEXTURES, "minecraft:block/limestone"));
+        addDispatch(new BlockModelEmpty<>(Blocks.STATUE_GRANITE_LOWER).setAllTextures(BLOCK_TEXTURES, "minecraft:block/granite"));
+        addDispatch(new BlockModelEmpty<>(Blocks.STATUE_GRANITE_UPPER).setAllTextures(BLOCK_TEXTURES, "minecraft:block/granite"));
+        addDispatch(new BlockModelEmpty<>(Blocks.STATUE_MARBLE_LOWER).setAllTextures(BLOCK_TEXTURES, "minecraft:block/marble"));
+        addDispatch(new BlockModelEmpty<>(Blocks.STATUE_MARBLE_UPPER).setAllTextures(BLOCK_TEXTURES, "minecraft:block/marble"));
+        addDispatch(new BlockModelEmpty<>(Blocks.STATUE_PIGMAN_LOWER).setAllTextures(BLOCK_TEXTURES, "minecraft:block/pigman"));
+        addDispatch(new BlockModelEmpty<>(Blocks.STATUE_PIGMAN_UPPER).setAllTextures(BLOCK_TEXTURES, "minecraft:block/pigman"));
+
     }
 }
 
